import { IChecker } from './checker';
import { IComposer } from './compose';
import { PAYLOAD_SYMBOL, REQUEST_SYMBOL } from './symbol';
export declare type Obj = {
    [name: string]: any;
};
export declare type Transformer = (params: any, options: any) => any;
export declare type PluginContext = {
    app: IApp;
};
export interface IMiddlewareContext {
    [REQUEST_SYMBOL]: IRequest;
    [PAYLOAD_SYMBOL]?: TPayload;
    [name: string]: any;
}
export declare type Middleware<Ctx = IMiddlewareContext> = (ctx: Ctx, next: () => Promise<any>) => Promise<any>;
export declare type NativePlugin<Ctx = IMiddlewareContext, P = Obj> = (ctx: PluginContext) => NormalPlugin<Ctx, P>;
export declare type NormalPlugin<Ctx = IMiddlewareContext, P = Obj> = {
    middlewares?: Middleware<Ctx> | Middleware<Ctx>[] | {
        [name: string]: Middleware<Ctx> | Middleware<Ctx>[];
    };
    props?: ((props: Ctx) => P) | P;
};
export declare type Plugin<Ctx = IMiddlewareContext> = NormalPlugin<Ctx> | NativePlugin;
export declare type RawPlugins<Ctx = IMiddlewareContext> = Plugin<Ctx>[];
export interface IHelper extends IChecker, IComposer {
}
export interface Plugins {
    middlewares: Obj;
    props: any[];
    [name: string]: any;
}
declare type TPayload = Obj | Transformer;
export interface IApp {
    query: (payload?: TPayload, meta?: Obj) => Promise<any>;
    helper: IHelper;
    ctx: IMiddlewareContext;
}
export interface IRequest {
    timelines: string[];
    service: (params: Obj, options: Obj) => Promise<any>;
    [name: string]: any;
}
export {};
